# alfresco

Alfresco - the Ruby gem for the Alfresco Content Services REST API

**Search API** Provides access to the search features of Alfresco Content Services.

This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.RubyClientCodegen

## Installation

Add this to the Gemfile:

    gem 'alfresco', '~> 1.0.0'

## Getting Started

Please follow the [installation](#installation) procedure and then run the following code:
```ruby
# Load the gem
require 'alfresco'

# Setup authorization
Alfresco.configure do |config|
  # Configure HTTP basic authorization: basicAuth
  config.host = 'YOUR HOST'
  config.username = 'YOUR USERNAME'
  config.password = 'YOUR PASSWORD'
end

api_instance = Alfresco::SearchApi.new

query_body = Alfresco::SearchRequest.new # SearchRequest | Generic query API


begin
  #Searches Alfresco
  result = api_instance.search(query_body)
  p result
rescue Alfresco::ApiError => e
  puts "Exception when calling SearchApi->search: #{e}"
end

```

## Documentation for API Endpoints

All URIs are relative to *https://localhost/alfresco/api/-default-/public/search/versions/1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*Alfresco::SearchApi* | [**search**](docs/SearchApi.md#search) | **POST** /search | Searches Alfresco


## Documentation for Models

 - [Alfresco::ContentInfo](docs/ContentInfo.md)
 - [Alfresco::Error](docs/Error.md)
 - [Alfresco::ErrorError](docs/ErrorError.md)
 - [Alfresco::GenericBucket](docs/GenericBucket.md)
 - [Alfresco::GenericBucketBucketInfo](docs/GenericBucketBucketInfo.md)
 - [Alfresco::GenericFacetResponse](docs/GenericFacetResponse.md)
 - [Alfresco::GenericMetric](docs/GenericMetric.md)
 - [Alfresco::Node](docs/Node.md)
 - [Alfresco::Pagination](docs/Pagination.md)
 - [Alfresco::PathElement](docs/PathElement.md)
 - [Alfresco::PathInfo](docs/PathInfo.md)
 - [Alfresco::RequestDefaults](docs/RequestDefaults.md)
 - [Alfresco::RequestFacetField](docs/RequestFacetField.md)
 - [Alfresco::RequestFacetFields](docs/RequestFacetFields.md)
 - [Alfresco::RequestFacetIntervals](docs/RequestFacetIntervals.md)
 - [Alfresco::RequestFacetIntervalsIntervals](docs/RequestFacetIntervalsIntervals.md)
 - [Alfresco::RequestFacetQueries](docs/RequestFacetQueries.md)
 - [Alfresco::RequestFacetQueriesInner](docs/RequestFacetQueriesInner.md)
 - [Alfresco::RequestFacetSet](docs/RequestFacetSet.md)
 - [Alfresco::RequestFields](docs/RequestFields.md)
 - [Alfresco::RequestFilterQueries](docs/RequestFilterQueries.md)
 - [Alfresco::RequestFilterQueriesInner](docs/RequestFilterQueriesInner.md)
 - [Alfresco::RequestHighlight](docs/RequestHighlight.md)
 - [Alfresco::RequestHighlightFields](docs/RequestHighlightFields.md)
 - [Alfresco::RequestInclude](docs/RequestInclude.md)
 - [Alfresco::RequestLimits](docs/RequestLimits.md)
 - [Alfresco::RequestLocalization](docs/RequestLocalization.md)
 - [Alfresco::RequestPagination](docs/RequestPagination.md)
 - [Alfresco::RequestPivot](docs/RequestPivot.md)
 - [Alfresco::RequestQuery](docs/RequestQuery.md)
 - [Alfresco::RequestRange](docs/RequestRange.md)
 - [Alfresco::RequestScope](docs/RequestScope.md)
 - [Alfresco::RequestSortDefinition](docs/RequestSortDefinition.md)
 - [Alfresco::RequestSortDefinitionInner](docs/RequestSortDefinitionInner.md)
 - [Alfresco::RequestSpellcheck](docs/RequestSpellcheck.md)
 - [Alfresco::RequestStats](docs/RequestStats.md)
 - [Alfresco::RequestTemplates](docs/RequestTemplates.md)
 - [Alfresco::RequestTemplatesInner](docs/RequestTemplatesInner.md)
 - [Alfresco::ResponseConsistency](docs/ResponseConsistency.md)
 - [Alfresco::ResultBuckets](docs/ResultBuckets.md)
 - [Alfresco::ResultBucketsBuckets](docs/ResultBucketsBuckets.md)
 - [Alfresco::ResultNode](docs/ResultNode.md)
 - [Alfresco::ResultSetContext](docs/ResultSetContext.md)
 - [Alfresco::ResultSetContextFacetQueries](docs/ResultSetContextFacetQueries.md)
 - [Alfresco::ResultSetContextSpellcheck](docs/ResultSetContextSpellcheck.md)
 - [Alfresco::ResultSetPaging](docs/ResultSetPaging.md)
 - [Alfresco::ResultSetPagingList](docs/ResultSetPagingList.md)
 - [Alfresco::ResultSetRowEntry](docs/ResultSetRowEntry.md)
 - [Alfresco::SearchEntry](docs/SearchEntry.md)
 - [Alfresco::SearchEntryHighlight](docs/SearchEntryHighlight.md)
 - [Alfresco::SearchRequest](docs/SearchRequest.md)
 - [Alfresco::UserInfo](docs/UserInfo.md)


## Documentation for Authorization


### basicAuth

- **Type**: HTTP basic authentication
